#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "mainstuff.h"

static char *fullsizedir;
static char *thumbnailsdir;

void on_thumbnails_clicked (GtkButton *button, gpointer user_data)
{
   thumbnailsDialog(button, user_data);
}

void on_htmlpages_clicked  (GtkButton *button, gpointer user_data)
{
   generateHtml(button, user_data);
}

void on_viewhtml_clicked   (GtkButton *button, gpointer user_data)
{
   viewHtml(button, user_data);
}

void on_quit_clicked       (GtkButton *button, gpointer user_data)
{
   gtk_main_quit();
}

void on_cancel_clicked     (GtkButton *button, gpointer user_data)
{
   ;
}

void on_ok_clicked         (GtkButton *button, gpointer user_data)
{
   ;
}

void on_updatepreview_clicked (GtkEntry *entry, gpointer user_data)
{
   char fname[1024];
   
   Params *p = getParams(window1);
   
   snprintf(fname, sizeof(fname) -1,
	    "%s/%s%0*d.%s",p->fullsizedir,p->basename,
	    p->nrofdigits,p->startnr,p->jpgextension);
   
   setStringValue(window1,"namepreview",fname);
}

void saveFullsizeName(GtkWidget *w, gpointer user_data)
{
   ldebug(1,"New filename : %s \n",fullsizedir);
   setStringValue(window1,"fullsize",fullsizedir);

   on_updatepreview_clicked(lookup_widget(window1,"updatepreview"),user_data);
}

void on_browsefullsize_clicked (GtkButton *button, gpointer user_data)
{
   ldebug (1,"on_browsefullsize_clicked\n");

   fullsizedir = getStringValue(window1,"fullsize");
   
   newFileSelector(fullsizedir, &(fullsizedir),
		   saveFullsizeName, NULL, NULL );
}

void saveThumbnailsName(GtkWidget *w, gpointer user_data)
{
   ldebug(1,"New filename : %s \n",thumbnailsdir);
   setStringValue(window1,"thumbnails",thumbnailsdir);
}

void on_browsethumbnails_clicked (GtkButton *button, gpointer user_data)
{
   ldebug (1,"on_browsethumbnails_clicked\n");

   fullsizedir = getStringValue(window1,"thumbnails");
   
   newFileSelector(thumbnailsdir, &(thumbnailsdir),
		   saveThumbnailsName, NULL, NULL );
   
}

void on_thumbwidth_value_changed (GtkButton *button, gpointer user_data)
{
   ldebug (1,"on_thumbwidth_value_changed\n");
   if(getIntValue (window1, "thumbwidth") != 0)
     setIntValue (window1, "thumbheight", 0 );
}

void  on_thumbheight_value_changed (GtkButton *button, gpointer user_data)
{
   ldebug (1,"on_thumbheight_value_changed\n");
   if(getIntValue (window1, "thumbheight") != 0)
     setIntValue (window1, "thumbwidth", 0 );
}

